package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountType
// UnionValue: BlockLedger

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("BlockLedger")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class BlockLedger implements Account {
	public final AccountType type = AccountType.BLOCK_LEDGER;
	private Url url;
	private long index;
	private java.time.OffsetDateTime time;
	private BlockEntry[] entries;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public BlockLedger url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public BlockLedger url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public long getIndex() {
	    return index;
	}
	public void setIndex(final long value) {
	    this.index = value;
	}

	public BlockLedger index(final long value) {
	    setIndex(value);
	    return this;
	}
	public java.time.OffsetDateTime getTime() {
	    return time;
	}
	public void setTime(final java.time.OffsetDateTime value) {
	    this.time = value;
	}

	public BlockLedger time(final java.time.OffsetDateTime value) {
	    setTime(value);
	    return this;
	}
	public BlockEntry[] getEntries() {
	    return entries;
	}
	public void setEntries(final BlockEntry[] value) {
	    this.entries = value;
	}

	public BlockLedger entries(final BlockEntry[] value) {
	    setEntries(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.index == 0)) {
            marshaller.writeUint(3, this.index);
        }
        if (!(this.time == null)) {
            marshaller.writeTime(4, this.time);
        }
        if (!(this.entries == null)) {
            marshaller.writeValue(5, entries);
        }
        return marshaller.array();
    }
}
